10 DIM S(101),Q(101)
20 K=10
30 PRINT "DETACT-QS  VERSION 1.3   WRITTEN BY D.D. EVANS  1985"
40 PRINT "CONTRIBUTION OF THE NATIONAL BUREAU OF STANDARDS (U.S.)."
50 PRINT "NOT SUBJECT TO COPYRIGHT."
60 PRINT " "
70 PRINT "QUASI-STEADY FIRE CALCULATION OF DETECTOR ACTUATION TIME"
80 PRINT "BELOW AN UNCONFINED CEILING BASED ON ALPERT'S EQUATIONS"
90 PRINT "AS PUBLISHED IN FIRE TECHNOLOGY AUGUST 1972."
100 PRINT " "
110 PRINT " "
120 PRINT "                   USER SUPPLIED INPUT"
130 PRINT " "
140 PRINT "HEIGHT OF CEILING ABOVE FUEL (FEET)              ";
150 INPUT HF
151 H=HF*.3048
160 PRINT " "
170 PRINT "DISTANCE OF DETECTOR FROM AXIS OF FIRE (FEET)    ";
180 INPUT RF
181 R=RF*.3048
190 PRINT " "
200 PRINT "INITIAL ROOM TEMPERATURE (FAHRENHEIT)              ";
210 INPUT T1F
211 T1=5/9*(T1F-32)
220 PRINT " "
230 PRINT "DETECTOR ACTUATION TEMPERATURE (FAHRENHEIT)"
240 PRINT "(140 F = 60 C   160 F = 71 C   165 F = 74 C)       ";
250 INPUT T9F
251 T9=5/9*(T9F-32)
260 PRINT " "
270 PRINT "DETECTOR RESPONSE TIME INDEX (RTI)  (ft*s)^(1/2)   ";
280 INPUT LF
281 L=LF*.55209
290 PRINT " "
300 PRINT "NEXT A DESCRIPTION OF THE FIRE HEAT RELEASE RATE AS A"
310 PRINT "AS A FUNCTION OF TIME MUST BE CONSTRUCTED. THIS WILL BE"
320 PRINT "DONE BY THE USER ENTERING KEY HEAT RELEASE RATES ALONG"
330 PRINT "THE DESIRED FIRE CURVE. FOR THE USERS INFORMATION THE"
340 PRINT "MINIMUM HEAT RELEASE RATE NECESSARY TO ACTUATE THE"
350 PRINT "DETECTOR AT THE LOCATION GIVEN IS";
360 X=((T9-T1)*H/5.38*R^(2/3))^(3/2)
370 IF R/H>.18 THEN 390
380 X=((T9-T1)*H^(5/3)/16.9)^(3/2)
390 X=X+.5
400 X=INT(X)
410 PRINT X;
420 PRINT " kW."
430 PRINT " "
440 PRINT " "
450 PRINT "ENTER KEY HEAT RELEASE RATES THAT DETERMINE THE SHAPE OF THE"
460 PRINT "DESIRED FIRE DEVELOPMENT CURVE.  USUALLY THE FIRST DATA"
470 PRINT "PAIR WILL BE  ( TIME  0   HEAT RELEASE  0 ). UP TO 100"
480 PRINT "PAIRS CAN BE ENTERED.  TO STOP ENTERING DATA  ENTER ANY"
490 PRINT "NEGATIVE TIME VALUE.  THE PROGRAM WILL GENERATE HEAT"
500 PRINT "RELEASE RATE VALUES BETWEEN THE VALUES ENTERED AS NEEDED"
510 PRINT "BASED ON A STRAIGHT LINE INTERPOLATION BETWEEN POINTS AT"
520 PRINT "ONE SECOND INTERVALS"
530 PRINT " "
540 PRINT " "
550 N=1
560 FOR I=1 TO 101
570 S(I)=1E+20
580 Q(I)=0
590 NEXT I
600 PRINT N;
610 PRINT "..   TIME (SEC)       ";
620 INPUT S(N)
630 IF S(N)<0 THEN 710
640 PRINT " "
650 PRINT "        HEAT RELEASE (kW)";
660 INPUT Q(N)
670 PRINT " "
680 N=N+1
690 PRINT " "
700 GOTO 600
710 S(N)=S(N-1)+1
720 PR=0
730 PRINT " "
740 PRINT "SEND OUTPUT TO PRINTER (Y OR N) ";
750 INPUT A$
760 IF A$="Y" OR A$="y" THEN PR=1
770 PRINT " "
771 FLAG=0
780 PRINT "CEILING HEIGHT=";H;"m   ";HF;"ft"
781 PRINT "RADIUS=";R;"m    ";RF;"ft"
782 PRINT "DET ACT TEMP=";T9;"C    ";T9F;"F"
783 PRINT "RTI=";L;"(m*s)^(1/2)    ";LF;"(ft*s)^(1/2)"
790 PRINT " "
800 PRINT "      TIME      FIRE  GAS TEMP  DET TEMP  GAS TEMP  DET TEMP"
810 PRINT "       sec        kW         C         C         F         F"
820 IF PR=0 THEN 920
830 LPRINT "DETACT-QS  VERSION 1.3"
840 LPRINT " "
850 LPRINT "CEILING HEIGHT=";H;"m    ";HF;"ft"
860 LPRINT "DETECTOR DISTANCE FROM AXIS OF FIRE=";R;"m    ";RF;"ft"
870 LPRINT "DETECTOR ACTUATION TEMP=";T9;"C    ";T9F;"F"
880 LPRINT "RTI=";L;"(m*s)^(1/2)    ";LF;"(ft*s)^(1/2)"
890 LPRINT " "
900 LPRINT "      TIME      FIRE  GAS TEMP  DET TEMP  GAS TEMP  DET TEMP"
910 LPRINT "       sec        kW         C         C         F         F"
920 I=N-1
930 P=K
940 N=0
950 T4=T1
960 T5=T1
970 T6=T1
980 J=1
990 IF N<S(J+1) THEN 1020
1000 J=J+1
1010 GOTO 990
1020 O=(N-S(J))/(S(J+1)-S(J))*(Q(J+1)-Q(J))+Q(J)
1030 T4=T5
1040 S6=T6
1050 T6=16.9*O^(2/3)/H^(5/3)+T1
1060 IF R/H<=.18 THEN 1080
1070 T6=5.38*(O/R)^(2/3)/H+T1
1080 V6=.95*(O/H)^(1/3)
1090 IF R/H<=.15 THEN 1110
1100 V6=.2*O^(1/3)*H^(1/2)/R^(5/6)
1110 IF V6>.1 THEN 1130
1120 V6=.1
1130 L1=L/V6^.5
1140 B=T6-S6
1150 T5=T4+(S6-T4)*(1-EXP(-1/L1))+B*L1*(EXP(-1/L1)+1/L1-1)
1160 IF P<K THEN 1200
1161 IF O>1 THEN FLAG=1
1162 IF FLAG=1 AND O<.0001 GOTO 1232
1163 S6F=9/5*S6+32
1164 T4F=9/5*T4+32
1170 PRINT USING "########.#";N,O,S6,T4,S6F,T4F
1180 IF PR=1 THEN LPRINT USING "########.#";N,O,S6,T4,S6F,T4F
1190 P=0
1200 N=N+1
1210 P=P+1
1220 IF T5<T9 THEN 990
1230 GOSUB 1680
1231 GOTO 1240
1232 PRINT " "
1233 PRINT " *** DETECTOR DID NOT ACTUATE ***"
1234 PRINT " "
1235 IF PR=0 THEN 1350
1236 LPRINT " "
1237 LPRINT " *** DETECTOR DID NOT ACTUATE ***"
1238 GOTO 1350
1240 PRINT " "
1250 PRINT "       **** DETECTOR ACTUATION AT";
1260 PRINT USING "######.#";E;
1270 PRINT " SECONDS ****"
1280 PRINT " "
1290 IF PR=0 THEN 1350
1300 LPRINT " "
1310 LPRINT "       **** DETECTOR ACTUATION AT";
1320 LPRINT USING "######.#";E;
1330 LPRINT " SECONDS ****"
1340 LPRINT " "
1350 PRINT "TYPE A CARRIAGE RETURN TO CONTINUE";
1360 INPUT A$
1370 PRINT " "
1380 PRINT "ANALYZE SAME FIRE WITH DIFFERENT DETECTOR (Y OR N) ";
1390 INPUT A$
1400 IF A$="Y" OR A$="y" THEN 1420
1410 END
1420 PRINT "CHANGE RTI VALUE (Y OR N) ";
1430 INPUT A$
1440 IF A$<>"Y" AND A$<>"y" THEN 1470
1450 PRINT "NEW VALUE = ";
1460 INPUT LF
1470 PRINT "CHANGE ACTUATION TEMPERATURE (Y OR N) ";
1480 INPUT A$
1490 IF A$<>"Y" AND A$<>"y" THEN 1520
1500 PRINT "NEW VALUE = ";
1510 INPUT T9F
1520 PRINT "CHANGE FUEL TO CEILING HEIGHT (Y OR N) ";
1530 INPUT A$
1540 IF A$<>"Y" AND A$<>"y" THEN 1570
1550 PRINT "NEW VALUE= ";
1560 INPUT HF
1570 PRINT "CHANGE RADIUS OF DETECTOR FROM FIRE AXIS (Y OR N) ";
1580 INPUT A$
1590 IF A$<>"Y" AND A$<>"y" THEN 1620
1600 PRINT "NEW VALUE= ";
1610 INPUT RF
1620 PRINT "CHANGE PRINTOUT INTERVAL (Y OR N) ";
1630 INPUT A$
1640 IF A$<>"Y" AND A$<>"y" THEN 1661
1650 PRINT "NEW VALUE = ";
1660 INPUT K
1661 H=HF*.3048
1662 R=RF*.3048
1663 T9=5/9*(T9F-32)
1664 L=LF*.55209
1670 GOTO 770
1680 E=N-1+(T9-T4)/(T5-T4)
1690 E=E*100+.5
1700 E=INT(E)
1710 E=E/100
1720 RETURN
